<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="1100">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon color="purple"> mdi-cog-outline </v-icon>
          CONFIGURACIÓN
        </v-btn>
      </template>
      <v-card :class="'modalSystem'">
        <v-card>
          <div class="container">
            <v-btn icon right @click="dialog = false" class="float-right">
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <h3 class="text-center">CONFIGURACIÓN PRESUPUESTO</h3>
            <h4 class="text-center font-weight-regular">Unidades de costo</h4>
            <form>
              <div class="d-flex justify-space-between mt-2">
                <v-row class="mt-6">
                  <v-col md="4">
                    <v-text-field
                      v-model="form.titulo"
                      label="Título Unidad de Costo"
                      type="text"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      outlined
                    />
                  </v-col>
                  <v-col md="4">
                    <v-text-field
                      v-model="form.unidadUno"
                      label="Nombre unidad 1"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="4">
                    <v-text-field
                      v-model="form.unidadDos"
                      label="Nombre unidad 2"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="4">
                    <v-text-field
                      v-model="form.unidadTres"
                      label="Nombre unidad 3"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="4">
                    <v-text-field
                      v-model="form.unidadCuatro"
                      label="Nombre unidad 4"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col md="4">
                    <v-text-field
                      v-model="form.unidadCinco"
                      label="Nombre unidad 5"
                      :hide-details="true"
                      :maxlength="'15'"
                      :minlenght="'0'"
                      type="text"
                      outlined
                    />
                  </v-col>
                  <v-col
                    md="12"
                    class="
                      text-center
                      d-flex
                      justify-center
                      pt-md-6
                      pb-md-12
                      mx-lg-auto
                    "
                  >
                    <v-btn
                      class="
                        button-text
                        v-btn v-btn--outlined v-btn--rounded
                        theme--light
                        v-size--default
                        tway-violet--text
                      "
                      outlined
                      color="indigo lighten-2"
                      @click="
                        saveStage;
                        dialog = false;
                      "
                    >
                      <v-icon color="purple"> mdi-content-save </v-icon>
                      Guardar Unidad
                    </v-btn>
                  </v-col>
                </v-row>
              </div>
            </form>
            <!-- ETAPAS -->
            <v-divider></v-divider>
            <h4 class="text-center font-weight-regular mt-6">
              Ingresa nuevo presupuesto
            </h4>
            <v-simple-table class="table mt-5" fixed-header>
              <template>
                <thead>
                  <tr>
                    <th class="text-center" width="5%" scope="col">ID</th>
                    <th class="text-center" width="20%" scope="col">Año</th>
                    <th class="text-center" width="20%" scope="col">Mes</th>
                    <th class="text-center" width="20%" scope="col">
                      Centro Costo
                    </th>
                    <th class="text-center" width="20%" scope="col">
                      Presupuesto
                    </th>
                    <th class="text-center" scope="col">Acciones</th>
                  </tr>
                </thead>
                <tbody>
                  <tr
                    :v-if="items.length > 0"
                    v-for="(item, index) in items"
                    :key="index"
                    :class="item.isVisible ? activeClass : hidden"
                    class="edit_row"
                  >
                    <td class="text-center">{{ index + 1 }}</td>
                    <td class="text-center">
                      <v-select
                        :items="item.anios"
                        label="Año"
                        v-model="item.anio"
                        outlined
                      ></v-select>
                    </td>
                    <td class="text-center">
                      <v-select
                        :items="item.meses"
                        label="Mes"
                        v-model="item.mes"
                        outlined
                      ></v-select>
                    </td>
                    <td class="text-center">
                      <v-select
                        :items="item.costos"
                        label="Unidad de Costo"
                        v-model="item.costo"
                        outlined
                      ></v-select>
                    </td>
                    <td class="text-center">
                      <span class="peso">$</span>
                      <v-text-field
                        v-model="item.presupuesto"
                        label="Monto"
                        type="number"
                        maxlength="15"
                        minlenght="0"
                        :counter="15"
                        outlined
                      ></v-text-field>
                    </td>
                    <td class="text-center buttons">
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="primary"
                            class="edit"
                            @click="saveItem(item)"
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon>edit</v-icon>
                          </v-btn>
                        </template>
                        <span>Editar</span>
                      </v-tooltip>
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="primary"
                            class="save"
                            @click="saveItem(item)"
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon>save</v-icon>
                          </v-btn>
                        </template>
                        <span>Guardar</span>
                      </v-tooltip>
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="error"
                            v-bind="attrs"
                            v-on="on"
                            @click="removeItem()"
                          >
                            <v-icon>delete</v-icon>
                          </v-btn>
                        </template>
                        <span>Eliminar</span>
                      </v-tooltip>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
            <v-row>
              <v-col md="12" class="justify-center">
                <div class="btn d-flex justify-center mt-6">
                  <v-btn
                    class="
                      button-text
                      v-btn v-btn--outlined v-btn--rounded
                      theme--light
                      v-size--default
                      tway-violet--text
                      justify-center
                    "
                    outlined
                    color="indigo lighten-2"
                    @click="AddItem()"
                  >
                    <v-icon color="purple"> mdi-plus </v-icon>
                    Agregar otro
                  </v-btn>
                </div>
              </v-col>
            </v-row>
          </div>
        </v-card>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import BudgetService from "@/services/pmo/budget/budgetService";
import PlanificationService from "@/services/pmo/planification/planificationService";

export default {
  data: () => {
    return {
      dialog: false,
      form: {
        titulo: "",
        unidadUno: "",
        unidadDos: "",
        unidadTres: "",
        unidadCuatro: "",
        unidadCinco: "",
      },
      items: [
        {
          anio: "",
          mes: "",
          costo: "",
          presupuesto: "",
          anios: ["2019", "2020", "2021", "2022"],
          costos: ["Dolares", "Pesos", "Euros", "Libras"],
          meses: [
            "Enero",
            "Febrero",
            "Marzo",
            "Abril",
            "Mayo",
            "Junio",
            "Julio",
            "Agosto",
            "Septiembre",
            "Octubre",
            "Noviembre",
            "Diciembre",
          ],
        },
      ],
      nameRules: [
        (v) => !!v || "Requerido.",
        (v) => v.length <= 15 || "Máximo 15 carácteres.",
      ],
      isVisible: true,
      activeClass: "is-visible",
    };
  },
  methods: {
    AddItem() {
      this.items.push({
        anio: this.anio,
        mes: this.mes,
        costo: this.costo,
        presupuesto: this.presupuesto,
      });
    },
    removeItem() {
      if (this.items.length > 1) {
        this.items.splice(this.items, 1);
      }
    },
    saveItem(item) {
      item.isVisible = !item.isVisible;
      this.$forceUpdate();
    },
    saveStage() {
      let test = {
        titulo: this.form.titulo,
        unidadUno: this.form.unidadUno,
        unidadDos: this.form.unidadDos,
        unidadTres: this.form.unidadTres,
        unidadCuatro: this.form.unidadCuatro,
        unidadCinco: this.form.unidadCinco,
      };

      this.loading.saveStage = true;

      PlanificationService.saveStage(test)
        .then(() => {
          BudgetService.stages()
            .then((data) => {
              this.etapas = data;
            })
            .catch((err) => console.dir(err));

          BudgetService.stagesInExistence()
            .then((data) => {
              this.combos.selectEtapas = data;
            })
            .catch((err) => console.dir(err));
        })
        .catch((err) => {
          let message = err.response.data.message;
          this.alert.saveStage = true;
          this.messageError.saveStage = message;
          console.dir(err);
        })
        .finally(() => {
          this.loading.saveStage = false;
          setTimeout(() => (this.alert.saveStage = false), 4000);
          this.clearForm();
        });
    },
  },
  // methods: {
  //   saveStage() {
  //     let test = {
  //       proyectoId: this.setup.id,
  //       orden: 2,
  //       nombre: "Bob",
  //       etapa: this.stage.name,
  //       inicio: this.formatDate(this.stage.dateStart),
  //       termino: this.formatDate(this.stage.dateEnd),
  //     };

  //     this.loading.saveStage = true;

  //     PlanificationService.saveStage(test)
  //       .then(() => {
  //         BudgetService.stages()
  //           .then((data) => {
  //             this.etapas = data;
  //           })
  //           .catch((err) => console.dir(err));

  //         BudgetService.stagesInExistence()
  //           .then((data) => {
  //             this.combos.selectEtapas = data;
  //           })
  //           .catch((err) => console.dir(err));
  //       })
  //       .catch((err) => {
  //         let message = err.response.data.message;
  //         this.alert.saveStage = true;
  //         this.messageError.saveStage = message;
  //         console.dir(err);
  //       })
  //       .finally(() => {
  //         this.loading.saveStage = false;
  //         setTimeout(() => (this.alert.saveStage = false), 4000);
  //         this.clearForm();
  //       });
  //   },
  // }
};
</script>

<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
</style>
